﻿using System.Data.OleDb;

using DevExpress.Utils;
using DevExpress.XtraEditors;
using DevExpress.XtraGrid;
using DevExpress.XtraGrid.Views.Grid;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 연결
        /// </summary>
        private OleDbConnection connection;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.connection = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=nwind.mdb");

            this.gridView.InitializeView
            (
                true,                           // Multi Select
                GridMultiSelectMode.CellSelect, // Grid Multi Select Mode
                DrawFocusRectStyle.CellFocus,   // Draw Focus Rect Style
                true,                           // Show Indicator
                true,                           // Show Column Headers
                true,                           // Allow Column Moving
                true,                           // Allow Column Resizing
                true,                           // Allow Filter
                true,                           // Allow Sort
                false,                          // Allow Cell Merge
                EditorShowMode.Default,         // Editor Show Mode
                false                           // Editable
            );

            this.gridView.OptionsBehavior.AutoPopulateColumns = true;

            this.gridControl.DataSource = Product.GetProductList(this.connection);

            FormatConditionIconSetIcon formatConditionIconSetIcon1 = new FormatConditionIconSetIcon();

            formatConditionIconSetIcon1.ValueComparison = FormatConditionComparisonType.GreaterOrEqual;
            formatConditionIconSetIcon1.Value           = 67; // 타겟 범위 : 67% <= 값
            formatConditionIconSetIcon1.PredefinedName  = "Stars3_1.png";

            FormatConditionIconSetIcon formatConditionIconSetIcon2 = new FormatConditionIconSetIcon();

            formatConditionIconSetIcon2.ValueComparison = FormatConditionComparisonType.GreaterOrEqual;
            formatConditionIconSetIcon2.Value           = 33; // 타겟 범위 : 33% <= 값 < 67%
            formatConditionIconSetIcon2.PredefinedName  = "Stars3_2.png";

            FormatConditionIconSetIcon formatConditionIconSetIcon3 = new FormatConditionIconSetIcon();

            formatConditionIconSetIcon3.ValueComparison = FormatConditionComparisonType.GreaterOrEqual;
            formatConditionIconSetIcon3.Value           = 0; // 타겟 범위 : 0% <= 값 < 33%
            formatConditionIconSetIcon3.PredefinedName  = "Stars3_3.png";

            FormatConditionIconSet formatConditionIconSet = new FormatConditionIconSet();

            formatConditionIconSet.ValueType = FormatConditionValueType.Percent;

            formatConditionIconSet.Icons.Add(formatConditionIconSetIcon1);
            formatConditionIconSet.Icons.Add(formatConditionIconSetIcon2);
            formatConditionIconSet.Icons.Add(formatConditionIconSetIcon3);

            FormatConditionRuleIconSet formatConditionRuleIconSet = new FormatConditionRuleIconSet();

            formatConditionRuleIconSet.IconSet = formatConditionIconSet;

            GridFormatRule gridFormatRule = new GridFormatRule();

            gridFormatRule.Column = this.gridView.Columns["UnitPrice"];
            gridFormatRule.Rule   = formatConditionRuleIconSet;

            this.gridView.FormatRules.Add(gridFormatRule);

            this.gridView.BestFitColumns();
        }

        #endregion
    }
}